<link rel="import" href="../polymer/polymer-element.html" />

<dom-module id="ciclo-vida">
    <template>
        <style>
            :host {
                display: block;
            }
        </style>
        <h2>Hello [[prop1]]!</h2>
    </template>

    <script>
        /**
         * `ciclo-vida`
         * Aprendiendo el ciclo de vida de Polymer
         *
         * @customElement
         * @polymer
         * @demo demo/index.html
         */
        class CicloVida extends Polymer.Element {
            constructor() {
                super();
                console.log("Un elemento se ha creado");
            }
            connectedCallback() {
                super.connectedCallback();
                console.log("El elemento se ha introducido en el DOM");
            }
            disconnectedCallback() {
                super.disconnectedCallback();
                console.log("El elemento se ha eliminado en el DOM");
            }
            attributeChangedCallback(name, oldVal, newVal) {
                super.attributeChangedCallback(name, oldVal, newVal);
                console.log("Atributo cambiado");
            }
            ready() {
                super.ready();
                console.log(`El elemento ${CicloVida.is} está listo`);
            }
            static get is() {
                return "ciclo-vida";
            }
            static get properties() {
                return {
                    prop1: {
                        type: String,
                        value: "ciclo-vida",
                    },
                };
            }
        }

        window.customElements.define(CicloVida.is, CicloVida);
    </script>
</dom-module>
